#資料5a
# -*- coding: utf-8 -*-
##*********************************************************
#   li_battery_lifespan_regression_ prediction.py         *
#        劣化予測プログラム       　　　　                *
##*********************************************************

import keras
from keras.models import Sequential
from keras.layers import Dense, Activation, Dropout
import numpy as np
import matplotlib.pyplot as plt
import sys
import pandas as pd
from sklearn.model_selection import train_test_split
from sklearn.preprocessing import StandardScaler
from sklearn.metrics import mean_squared_error


# load of data
data_set = pd.read_csv("temp_data.csv",sep=",",header=0)

#separation of input(x) and target(y)
x = pd.DataFrame(data_set.drop("寿命",axis=1))
y = pd.DataFrame(data_set["寿命"])


#y_train creation for comparison
y2 = np.array(y.T)
y = y2[0]

# standardization of x
scaler = StandardScaler()
scaler.fit(x)
x_train = scaler.transform(x)


# input and output for keras
x_train = x_train.astype(np.float)

X = x_train
#y = y_train

# number,dimensio,class_number
(n_samples, n_features) = X.shape

# 4 layers
model = Sequential()
# input layer
model.add(Dense(units=50, activation='relu', input_shape=(n_features,)))
# Dropout
model.add(Dropout(0.1))
# second layer
model.add(Dense(units=20, activation='relu'))
# Dropout
model.add(Dropout(0.1))
# output layer
model.add(Dense(1))
model.summary

# compile
model.compile(loss='mean_squared_error', optimizer='adam', metrics=['mae'])

# learning
history = model.fit(X, y, epochs=500, batch_size=16, verbose=2)

#loss_graph
plt.xlabel('time step')
plt.ylabel('loss')
plt.ylim(0,10000)
loss, = plt.plot(history.history['loss'], c='#E69F00')
plt.show()

# load of new_data
new_data = pd.read_csv("test_data.csv",sep=",",header=0)

x1 = pd.DataFrame(new_data.drop("寿命",axis=1))
#y_test=pd.DataFrame(new_data["寿命"])

#change to form of DataFrame
x = pd.DataFrame(x1)


# standardization of x
x_test = scaler.transform(x)


# prediction
y_pred = model.predict(x_test, verbose=0)

print("prediction:",y_pred)
print("END")